package com.yice.webadmin.app.controller;

import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.github.pagehelper.page.PageMethod;
import com.yice.webadmin.app.vo.*;
import com.yice.webadmin.app.dto.*;
import com.yice.webadmin.app.model.*;
import com.yice.webadmin.app.service.*;
import com.yice.common.core.object.*;
import com.yice.common.core.util.*;
import com.yice.common.core.constant.*;
import com.yice.common.core.annotation.MyRequestBody;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * 数据集详情操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "数据集详情管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/datasetDetail")
public class DatasetDetailController {

    @Autowired
    private DatasetDetailService datasetDetailService;

    /**
     * 新增数据集详情数据。
     *
     * @param datasetDetailDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"datasetDetailDto.detailId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody DatasetDetailDto datasetDetailDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetDetailDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetDetail datasetDetail = MyModelUtil.copyTo(datasetDetailDto, DatasetDetail.class);
        datasetDetail = datasetDetailService.saveNew(datasetDetail);
        return ResponseResult.success(datasetDetail.getDetailId());
    }

    /**
     * 更新数据集详情数据。
     *
     * @param datasetDetailDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody DatasetDetailDto datasetDetailDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetDetailDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetDetail datasetDetail = MyModelUtil.copyTo(datasetDetailDto, DatasetDetail.class);
        DatasetDetail originalDatasetDetail = datasetDetailService.getById(datasetDetail.getDetailId());
        if (originalDatasetDetail == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetDetailService.update(datasetDetail, originalDatasetDetail)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除数据集详情数据。
     *
     * @param detailId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long detailId) {
        if (MyCommonUtil.existBlankArgument(detailId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(detailId);
    }

    /**
     * 列出符合过滤条件的数据集详情列表。
     *
     * @param datasetDetailDtoFilter 过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<DatasetDetailVo>> list(
            @MyRequestBody DatasetDetailDto datasetDetailDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetDetail datasetDetailFilter = MyModelUtil.copyTo(datasetDetailDtoFilter, DatasetDetail.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetDetail.class);
        List<DatasetDetail> datasetDetailList =
                datasetDetailService.getDatasetDetailListWithRelation(datasetDetailFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetDetailList, DatasetDetail.INSTANCE));
    }

    /**
     * 查看指定数据集详情对象详情。
     *
     * @param detailId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<DatasetDetailVo> view(@RequestParam Long detailId) {
        DatasetDetail datasetDetail = datasetDetailService.getByIdWithRelation(detailId, MyRelationParam.full());
        if (datasetDetail == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetDetailVo datasetDetailVo = DatasetDetail.INSTANCE.fromModel(datasetDetail);
        return ResponseResult.success(datasetDetailVo);
    }

    private ResponseResult<Void> doDelete(Long detailId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        DatasetDetail originalDatasetDetail = datasetDetailService.getById(detailId);
        if (originalDatasetDetail == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetDetailService.remove(detailId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
